<?php

$map = new Mapper(256,256);
$chunks = new Mapper(32,32);

for ($m=0;$m<128;$m++) {
    for ($k=0;$k<360;$k++) {
        $distance = $m;
        $angle = $k;
        $result = $distance * sin($angle*0.01745329251994329576923690768489); // rad = angle * pi/180
        $x = intval(round($result,0,PHP_ROUND_HALF_UP));
        $result = $distance * cos($angle*0.01745329251994329576923690768489);
        $y = intval(round($result,0,PHP_ROUND_HALF_UP));
        $map->setPixel($x+128,$y+128,1);
        $a = intdiv($x+128,8);
        $b = intdiv($y+128,8);
        $chunks->setPixel($a,$b,1);
        //$map[$y+$m][$x+$m] = 1;
    }
}

$rl = new RLE();
$rleDump = '';
for ($angle=0;$angle<360;$angle++) {
    $rowCoordsX = array();
    $rowCoordsY = array();
    for ($distance=0;$distance<128;$distance++) {
        $result = $distance * sin($angle*0.01745329251994329576923690768489);
        $x = intval(round($result,0,PHP_ROUND_HALF_UP));
        $result = $distance * cos($angle*0.01745329251994329576923690768489);
        $y = intval(round($result,0,PHP_ROUND_HALF_UP));
        $rowCoordsX[$distance] = $x;
        $rowCoordsY[$distance] = $y;
    }
    $compacted = array();
    $compacted[0] = $rowCoordsX[0];
    $compacted[1] = $rowCoordsY[0];
    $counter = 0;
    for ($i=1;$i<128;$i++) {
        $xx = abs($rowCoordsX[$i]-$rowCoordsX[$i-1]);
        $xy = abs($rowCoordsY[$i]-$rowCoordsY[$i-1]);
        $compacted[$counter] = $xx*16 + $xy;
        $counter++;
    }
    
    $rl->reset();
    for ($i=0;$i<127;$i++) {
        echo ' '.str_pad(dechex($compacted[$i]),2,'0',STR_PAD_LEFT);
        $rl->addByte($compacted[$i]);
    }
    echo "\n";
    $rleDump.= $rl->hexDump()."\n";
    $rl->reset();


}
echo $rleDump;
$img  = @imagecreatetruecolor(256, 256);
$col = imagecolorallocate($img,127,127,127);
$white = imagecolorallocate($img,255,255,255);
$color = 0;
$mycols = array();

imagefill($img,0,0,$white);
for ($j=0;$j<256;$j++) {
    for ($i=0;$i<256;$i++) {

        if ($map->getPixel($i,$j) == 1) imagesetpixel($img,$i,$j,$col);
        
    }

}
$counter = 0;
for ($j=0;$j<32;$j++) {
    for ($i=0;$i<32;$i++) {

        if ($chunks->getPixel($i,$j) == 1) $counter++;
        
    }

}
echo "chunks=$counter\n";
imagepng($img,'c:/temp/image.png');


class Mapper {
    function __construct($x=256,$y=256) {
        $this->data = array();
        for ($j=0;$j<$y;$j++) {
            $this->data[$j] = array();
            for ($i=0;$i<$x;$i++) {
                $this->data[$j][$i] = 0;
            }
        }
    }
    function getPixel($x,$y) {
        return $this->data[$y][$x];
    }
    function setPixel($x,$y,$value=1) {
        $this->data[$y][$x] = $value;
    }
}

class RLE {
    function _construct() {
        $this->reset();
    }
    function reset() {
        $this->data = array();
        $this->count = array();
        $this->offset = -1;
    }
    function addByte($value) {
        if ($this->offset==-1) {
            $this->offset=0;
            $this->data[0] = $value;
            $this->count[0] = $value;
            return true;
        }
        if ($this->data[$this->offset]==$value) {
            $this->count[$this->offset]++; // this class assumes maximum 256 byte chains
        } else {
            $this->offset++;
            $this->data[$this->offset]=$value;
            $this->count[$this->offset]=0;
        } 
        return true;
    }
    function hexDump() {

        $s = str_pad(dechex($this->offset+1),4,'0',STR_PAD_LEFT);
        if ($this->offset>-1) {
            for ($i=0;$i<=$this->offset;$i++) {
                $s.= str_pad(dechex($this->count[$i]),2,'0',STR_PAD_LEFT).str_pad(dechex($this->data[$i]),2,'0',STR_PAD_LEFT);
            }
        }
        return $s; 
    }
}
?>